VERSION 5.00
Begin VB.UserControl XQShellFunc 
   ClientHeight    =   495
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   435
   InvisibleAtRuntime=   -1  'True
   Picture         =   "XQShellFunc.ctx":0000
   ScaleHeight     =   495
   ScaleWidth      =   435
   ToolboxBitmap   =   "XQShellFunc.ctx":0C42
End
Attribute VB_Name = "XQShellFunc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Type SHFILEOPSTRUCT
 hWnd      As Long
 wFunc     As Long
 pFrom     As String
 pTo       As String
 fFlags    As Integer
 fAborted  As Boolean
 hNameMaps As Long
 sProgress As String
End Type
'Private Const MAX_PATH = 255
Private Const FO_MOVE = &H1
Private Const FO_COPY = &H2
Private Const FO_DELETE = &H3
Private Const FO_RENAME = &H4
Private Const FOF_MULTIDESTFILES = &H1
Private Const FOF_CONFIRMMOUSE = &H2
Private Const FOF_SILENT = &H4
Private Const FOF_RENAMEONCOLLISION = &H8
Private Const FOF_NOCONFIRMATION = &H10
Private Const FOF_WANTMAPPINGHANDLE = &H20
Private Const FOF_ALLOWUNDO = &H40
Private Const FOF_FILESONLY = &H80
Private Const FOF_SIMPLEPROGRESS = &H100
Private Const FOF_NOCONFIRMMKDIR = &H200
Private Const FOF_NOERRORUI = &H400 '//Hae?????
Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Declare Sub SHAddToRecentDocs Lib "shell32.dll" (ByVal uFlags As Long, ByVal LPCVOID As String)
Const c_AllowUndo As Boolean = True
Const c_Silent As Boolean = False            '//SIlentMode => NO Progress Dialog
Const c_SimpleMode As Boolean = False        '//Progress Dialog, but no Filename
'Const c_SimpleModeTitle As String = "Please wait..." '//Title for Dialog if Simple=TRUE
Const c_YesToAll As Boolean = False          '//The User won't be asked
Private bAllowUndo As Boolean
Private bSilent As Boolean
Private bSimpleMode As Boolean
'Private strSimpleModeTitle As String
Private bYesToAll As Boolean


Private Sub UserControl_InitProperties()
 bAllowUndo = c_AllowUndo
 bSilent = c_Silent
 bSimpleMode = c_SimpleMode
 'strSimpleModeTitle = c_SimpleModeTitle
 bYesToAll = c_YesToAll
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
 bAllowUndo = PropBag.ReadProperty("AllowUndo", c_AllowUndo)
 bSilent = PropBag.ReadProperty("Silent", c_Silent)
 bSimpleMode = PropBag.ReadProperty("SimpleMode", c_SimpleMode)
 'strSimpleModeTitle = PropBag.ReadProperty("SimpleModeTitle", c_SimpleModeTitle)
 bYesToAll = PropBag.ReadProperty("YesToAll", c_YesToAll)
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
 Call PropBag.WriteProperty("AllowUndo", bAllowUndo, c_AllowUndo)
 Call PropBag.WriteProperty("Silent", bSilent, c_Silent)
 Call PropBag.WriteProperty("SimpleMode", bSimpleMode, c_SimpleMode)
 'Call PropBag.WriteProperty("SimpleModeTitle", strSimpleModeTitle, c_SimpleModeTitle)
 Call PropBag.WriteProperty("YesToAll", bYesToAll, c_YesToAll)
End Sub
Private Sub UserControl_Resize()
 Width = 445
 Height = 500
End Sub
Private Function FileFunc(Func As Long, strFrom As String, strTo As String)
 Dim fHD As SHFILEOPSTRUCT
 Dim s1 As String, s2 As String, s3 As String
 s1 = strFrom & Chr$(0)
 s2 = strTo & Chr$(0)
 '//s3 = strSimpleModeTitle & Chr$(0)
 
 fHD.hWnd = UserControl.hWnd
 fHD.wFunc = Func
 fHD.pFrom = s1
 fHD.pTo = s2
 '//fHD.sProgress = s3
 
 If bAllowUndo Then fHD.fFlags = fHD.fFlags + FOF_ALLOWUNDO
 If bSilent Then fHD.fFlags = fHD.fFlags + FOF_SILENT
 If bYesToAll Then fHD.fFlags = fHD.fFlags + FOF_NOCONFIRMATION
 If bSimpleMode Then fHD.fFlags = fHD.fFlags + FOF_SIMPLEPROGRESS
    
 Dim i As Long: i = 0
 i = SHFileOperation(fHD)
 Debug.Print "SHFileOperation: " & i
 
 If i = 0 Then '//OK
  If fHD.fAborted Then '//User has pushed cancel
   FileFunc = False
  Else
   FileFunc = True
  End If
 Else
  FileFunc = False
 End If
End Function
'////////////////////////////////////
'/---------Publics-------------------
Public Property Get AllowUndo() As Boolean
Attribute AllowUndo.VB_Description = "Returns/sets if the action can be undone."
Attribute AllowUndo.VB_HelpID = 70100
 AllowUndo = bAllowUndo
End Property
Public Property Let AllowUndo(ByVal New_AllowUndo As Boolean)
 bAllowUndo = New_AllowUndo
 PropertyChanged "AllowUndo"
End Property
Public Property Get Silent() As Boolean
Attribute Silent.VB_Description = "Returns/sets if a dialog should be displayed  (FALSE=Show dialog)."
Attribute Silent.VB_HelpID = 70700
 Silent = bSilent
End Property
Public Property Let Silent(ByVal New_Silent As Boolean)
 bSilent = New_Silent
 
 PropertyChanged "Silent"
End Property

Public Property Get SimpleMode() As Boolean
Attribute SimpleMode.VB_Description = "Returns/sets if the dialog is displaying filenames (FALSE) or not (TRUE)."
Attribute SimpleMode.VB_HelpID = 70800
 SimpleMode = bSimpleMode
End Property
Public Property Let SimpleMode(ByVal New_SimpleMode As Boolean)
 bSimpleMode = New_SimpleMode
 
 PropertyChanged "SimpleMode"
End Property
Public Property Get YesToAll() As Boolean
Attribute YesToAll.VB_Description = "Returns/sets if any appering dialog will be answered with ""yes to all"" (TRUE) or not (FALSE)."
Attribute YesToAll.VB_HelpID = 70900
 YesToAll = bYesToAll
End Property
Public Property Let YesToAll(ByVal New_YesToAll As Boolean)
 bYesToAll = New_YesToAll
 
 PropertyChanged "YesToAll"
End Property

'///////////////////////////////////Subs
Public Sub Copy(FileFrom As String, FileTo As String)
Attribute Copy.VB_Description = "Copys a file."
Attribute Copy.VB_HelpID = 70300
 Call FileFunc(FO_COPY, FileFrom, FileTo)
End Sub
Public Sub Move(FileFrom As String, FileTo As String)
Attribute Move.VB_Description = "Move files."
Attribute Move.VB_HelpID = 70500
 Call FileFunc(FO_MOVE, FileFrom, FileTo)
End Sub
Public Sub Rename(OriginalName As String, NewName As String)
Attribute Rename.VB_Description = "Rename a file."
Attribute Rename.VB_HelpID = 70600
 Call FileFunc(FO_RENAME, OriginalName, NewName)
End Sub
Public Sub Delete(Filename As String)
Attribute Delete.VB_Description = "Deletes a file (if AllowUndo=TRUE, the file is moved to the trashcan."
Attribute Delete.VB_HelpID = 70400
 Call FileFunc(FO_DELETE, Filename, "")
End Sub
Public Sub AddToDocumentList(Filename As String)
Attribute AddToDocumentList.VB_Description = "Adds a the document to the Start|Documents menu."
Attribute AddToDocumentList.VB_HelpID = 71000
 Dim s As String: s = Filename
 Dim l As Long
 
 Call SHAddToRecentDocs(2, ByVal s)
  
 Debug.Print "AddToRecentDocs: " & s
End Sub
Public Sub ClearDocumentList()
Attribute ClearDocumentList.VB_Description = "Clears the Start|Documents menu."
Attribute ClearDocumentList.VB_HelpID = 70200
 Call SHAddToRecentDocs(0, ByVal vbNullString)
End Sub
