VERSION 5.00
Begin VB.UserControl XQSysIcons 
   AutoRedraw      =   -1  'True
   ClientHeight    =   720
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1005
   ForwardFocus    =   -1  'True
   ScaleHeight     =   720
   ScaleWidth      =   1005
   ToolboxBitmap   =   "XQSysIcons.ctx":0000
   Begin VB.PictureBox picMain 
      BorderStyle     =   0  'None
      Height          =   555
      Left            =   0
      ScaleHeight     =   555
      ScaleWidth      =   855
      TabIndex        =   0
      Top             =   0
      Width           =   855
   End
End
Attribute VB_Name = "XQSysIcons"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Public Enum SYSICON_STYLE
 syicWin95Logo
 syicApplication
 syicStop
 syicQuestion
 syicWarning
 syicInformation
End Enum
Private Declare Function API_LoadIcon Lib "user32" Alias "LoadIconA" (ByVal hInstance As String, ByVal lpIconName As Long) As Long
Private Declare Function API_DrawIcon Lib "user32" Alias "DrawIcon" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal hIcon As Long) As Long
Private Declare Function API_DestroyIcon Lib "user32" Alias "DestroyIcon" (ByVal hIcon As Long) As Long
Private Const IDI_WINLOGO As Long = 32517
Private Const IDI_APPLICATION As Long = 32512
Private Const IDI_HAND As Long = 32513
Private Const IDI_QUESTION As Long = 32514
Private Const IDI_EXCLAMATION As Long = 32515
Private Const IDI_ASTERISK As Long = 32516
Private hCurHandle As Long   '//Handle of current Icon
Private iIcon As Integer     '//Integer-Value of current Icon
Private bEnab As Boolean     '//Enabled ??

Private Sub UserControl_Initialize()
 Debug.Print "Init..."
 bEnab = False '//To avoid the call of DrawIcon if SetBackColor is called
 
 Call SetBackColor
 hCurHandle = 0
 iIcon = 1
 bEnab = True
 
 NewIcon '//Create a new Icon
End Sub
Private Sub UserControl_Terminate()
 KillIcon
 Debug.Print "Exit..."
End Sub
Private Sub UserControl_AmbientChanged(PropertyName As String)
 If PropertyName = "BackColor" Then
  Call SetBackColor
 End If
End Sub
Private Sub SetBackColor()
 On Error GoTo Away
 UserControl.BackColor = Ambient.BackColor
 PicMain.BackColor = Ambient.BackColor
 DrawIcon
 On Error GoTo 0
Away:
End Sub
Private Sub picMain_Paint()
 Call DrawIcon
End Sub
Private Sub UserControl_Resize()
 PicMain.Width = Width
 PicMain.Height = Height
 Call DrawIcon
End Sub
'//Draws the current Icon (using hCurHandle)
Private Sub DrawIcon()
 If bEnab Then
  Debug.Print "Draw: " & API_DrawIcon(PicMain.hdc, 1, 1, hCurHandle)
 End If
 Debug.Print "Draw says: " & iIcon
End Sub
'//Destorys the Icon
Private Sub KillIcon()
 Debug.Print "Destroy: " & API_DestroyIcon(hCurHandle)
 
 If bEnab Then PicMain.Cls
End Sub
'//Create a new Icon
Private Sub NewIcon()
 '//Delete the old Icon
 KillIcon
 
 '//Check for wrong paramters
 If iIcon > 5 Then
  iIcon = 5
 End If
 If iIcon < 0 Then
  iIcon = 1
 End If
 
 Select Case iIcon
 Case syicWin95Logo
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_WINLOGO)
 Case syicApplication
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_APPLICATION)
 Case syicStop
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_HAND)
 Case syicQuestion
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_QUESTION)
 Case syicWarning
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_EXCLAMATION)
 Case syicInformation
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_ASTERISK)
 Case Else '//Default
  hCurHandle = API_LoadIcon(ByVal vbNullString, IDI_APPLICATION)
 End Select
 
 Debug.Print "LoadIcon: " & hCurHandle
End Sub
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
 iIcon = PropBag.ReadProperty("Style", 1)
 bEnab = PropBag.ReadProperty("Enabled", True)
 
 Call NewIcon
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
 Call PropBag.WriteProperty("Style", iIcon, 1)
 Call PropBag.WriteProperty("Enabled", bEnab, True)
End Sub
'//Publics-------------------------------
Public Sub Refresh()
Attribute Refresh.VB_UserMemId = -550
 DrawIcon
End Sub
Public Property Get Style() As SYSICON_STYLE
Attribute Style.VB_Description = "Returns/sets the icon to be displayed."
Attribute Style.VB_HelpID = 30100
Attribute Style.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Style.VB_UserMemId = 0
Attribute Style.VB_MemberFlags = "200"
 Style = iIcon
End Property
Public Property Let Style(ByVal vNewValue As SYSICON_STYLE)
 Dim i As Integer
 i = CInt(vNewValue)
 iIcon = i

 NewIcon
 DrawIcon
 Debug.Print "Style: " & iIcon
 PropertyChanged ("Style")
End Property
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Enabled.VB_UserMemId = -514
 Enabled = bEnab
End Property
Public Property Let Enabled(ByVal X As Boolean)
 If X = False Then
  KillIcon
  bEnab = False '//That way, KillIcon will clear the picturebox
 Else
  bEnab = True
  NewIcon
  DrawIcon
 End If
 
 PropertyChanged ("Enabled")
End Property
